TreeTableCell (JavaFX 28)
Description: declaration: module: javafx.controls, package: javafx.scene.control, class: TreeTableCell

# Class TreeTableCell<S,T>

java.lang.Object
javafx.scene.Node
javafx.scene.Parent
javafx.scene.layout.Region
javafx.scene.control.Control
javafx.scene.control.Labeled
javafx.scene.control.Cell<T>
javafx.scene.control.IndexedCell<T>
javafx.scene.control.TreeTableCell<S,T>

Type Parameters:
  `S` - The type of the TreeTableView generic type
  `T` - The type of the item contained within the Cell.

All Implemented Interfaces:
  `Styleable, EventTarget, Skinnable`

Direct Known Subclasses:
  `CheckBoxTreeTableCell, ChoiceBoxTreeTableCell, ComboBoxTreeTableCell, ProgressBarTreeTableCell, TextFieldTreeTableCell`

public class TreeTableCell<S,T> extends IndexedCell<T>
Represents a single row/column intersection in a `TreeTableView`. To represent this intersection, a TreeTableCell contains an `index` property, as well as a `tableColumn` property. In addition, a TreeTableCell instance knows what `TreeTableRow` it exists in.

A note about selection: A TreeTableCell visually shows it is selected when two conditions are met:

1. The `TableSelectionModel.isSelected(int, TableColumnBase)` method returns true for the row / column that this cell represents, and
2. The `cell selection mode` property is set to true (to represent that it is allowable to select individual cells (and not just rows of cells)).

Since:
  JavaFX 8.0
See Also:
  - `TreeTableView`
  - `TreeTableColumn`
  - `Cell`
  - `IndexedCell`
  - `TreeTableRow`

- ## Property Summary

  Properties
  Type
  Property
  Description
  `final ReadOnlyObjectProperty<TreeTableColumn<S,T>>`
  `tableColumn`
  The `TreeTableColumn` instance that backs this `TreeTableCell`.
  `final ReadOnlyObjectProperty<TreeTableRow<S>>`
  `tableRow`
  The `TreeTableRow` that this `TreeTableCell` currently finds itself placed within.
  `final ReadOnlyObjectProperty<TreeTableView<S>>`
  `treeTableView`
  The `TreeTableView` associated with this `TreeTableCell`.

  ### Properties declared in class IndexedCell

  `index`

  ### Properties declared in class Cell

  `editable, editing, empty, item, selected`

  ### Properties declared in class Labeled

  `alignment, contentDisplay, ellipsisString, font, graphic, graphicTextGap, labelPadding, lineSpacing, mnemonicParsing, textAlignment, textFill, textOverrun, text, textTruncated, underline, wrapText`

  ### Properties declared in class Control

  `contextMenu, skin, tooltip`

  ### Properties declared in class Region

  `background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

  ### Properties declared in class Parent

  `needsLayout`

  ### Properties declared in class Node

  `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, focusVisible, focusWithin, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragDone, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

- ## Field Summary

  ### Fields declared in class Region

  `USE_COMPUTED_SIZE, USE_PREF_SIZE`

  ### Fields declared in class Node

  `BASELINE_OFFSET_SAME_AS_HEIGHT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TreeTableCell()`
  Constructs a default TreeTableCell instance with a style class of 'tree-table-cell'.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final TreeTableColumn<S,T>`
  `getTableColumn()`
  Gets the value of the `tableColumn` property.
  `final TreeTableRow<S>`
  `getTableRow()`
  Gets the value of the property `tableRow`.
  `final TreeTableRow<S>`
  `getTreeTableRow()`
  Deprecated.
  Use `getTableRow()` instead.
  `final TreeTableView<S>`
  `getTreeTableView()`
  Gets the value of the `treeTableView` property.
  `final ReadOnlyObjectProperty<TreeTableColumn<S,T>>`
  `tableColumnProperty()`
  The `TreeTableColumn` instance that backs this `TreeTableCell`.
  `final ReadOnlyObjectProperty<TreeTableRow<S>>`
  `tableRowProperty()`
  The `TreeTableRow` that this `TreeTableCell` currently finds itself placed within.
  `final ReadOnlyObjectProperty<TreeTableView<S>>`
  `treeTableViewProperty()`
  The `TreeTableView` associated with this `TreeTableCell`.
  `final void`
  `updateTableColumn(TreeTableColumn<S,T> column)`
  Updates the `TreeTableColumn` associated with this `TreeTableCell`.
  `final void`
  `updateTableRow(TreeTableRow<S> row)`
  Updates the `TreeTableRow` associated with this `TreeTableCell`.
  `final void`
  `updateTreeTableColumn(TreeTableColumn<S,T> column)`
  Deprecated.
  Use `updateTableColumn(javafx.scene.control.TreeTableColumn<S,T>)` instead.
  `final void`
  `updateTreeTableRow(TreeTableRow<S> row)`
  Deprecated.
  Use `updateTableRow(javafx.scene.control.TreeTableRow<S>)` instead.
  `final void`
  `updateTreeTableView(TreeTableView<S> tv)`
  Updates the `TreeTableView` associated with this `TreeTableCell`.

  ### Methods declared in class IndexedCell

  `getIndex, indexProperty, updateIndex`

  ### Methods declared in class Cell

  `cancelEdit, commitEdit, editableProperty, editingProperty, emptyProperty, getInitialFocusTraversable, getItem, isEditable, isEditing, isEmpty, isItemChanged, isSelected, itemProperty, selectedProperty, setEditable, setItem, startEdit, updateItem, updateSelected`

  ### Methods declared in class Labeled

  `alignmentProperty, contentDisplayProperty, ellipsisStringProperty, fontProperty, getAlignment, getClassCssMetaData, getContentBias, getContentDisplay, getControlCssMetaData, getEllipsisString, getFont, getGraphic, getGraphicTextGap, getInitialAlignment, getLabelPadding, getLineSpacing, getText, getTextAlignment, getTextFill, getTextOverrun, graphicProperty, graphicTextGapProperty, isMnemonicParsing, isTextTruncated, isUnderline, isWrapText, labelPaddingProperty, lineSpacingProperty, mnemonicParsingProperty, setAlignment, setContentDisplay, setEllipsisString, setFont, setGraphic, setGraphicTextGap, setLineSpacing, setMnemonicParsing, setText, setTextAlignment, setTextFill, setTextOverrun, setUnderline, setWrapText, textAlignmentProperty, textFillProperty, textOverrunProperty, textProperty, textTruncatedProperty, underlineProperty, wrapTextProperty`

  ### Methods declared in class Control

  `computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, contextMenuProperty, createDefaultSkin, getContextMenu, getCssMetaData, getSkin, getTooltip, isResizable, setContextMenu, setSkin, setTooltip, skinProperty, tooltipProperty`

  ### Methods declared in class Region

  `backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, computePrefHeight, computePrefWidth, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

  ### Methods declared in class Parent

  `getBaselineOffset, getChildren, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, layoutChildren, needsLayoutProperty, requestLayout, requestParentLayout, setNeedsLayout, updateBounds`

  ### Methods declared in class Node

  `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, focusVisibleProperty, focusWithinProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragDone, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isFocusVisible, isFocusWithin, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookup, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragDoneProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, queryAccessibleAttribute, relocate, removeEventFilter, removeEventHandler, requestFocus, requestFocusTraversal, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragDone, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface Styleable

  `getStyleableNode`

- ## Property Details

  - ### tableColumn

    public final ReadOnlyObjectProperty<TreeTableColumn<S,T>> tableColumnProperty
    The `TreeTableColumn` instance that backs this `TreeTableCell`.
    See Also:
      - `getTableColumn()`
      - `tableColumnProperty()`

  - ### treeTableView

    public final ReadOnlyObjectProperty<TreeTableView<S>> treeTableViewProperty
    The `TreeTableView` associated with this `TreeTableCell`.
    See Also:
      - `getTreeTableView()`
      - `treeTableViewProperty()`

  - ### tableRow

    public final ReadOnlyObjectProperty<TreeTableRow<S>> tableRowProperty
    The `TreeTableRow` that this `TreeTableCell` currently finds itself placed within.
    See Also:
      - `getTableRow()`
      - `tableRowProperty()`

- ## Constructor Details

  - ### TreeTableCell

    public TreeTableCell()
    Constructs a default TreeTableCell instance with a style class of 'tree-table-cell'.

- ## Method Details

  - ### tableColumnProperty

    public final ReadOnlyObjectProperty<TreeTableColumn<S,T>> tableColumnProperty()
    The `TreeTableColumn` instance that backs this `TreeTableCell`.
    Returns:
      the `tableColumn` property
    See Also:
      - `getTableColumn()`

  - ### getTableColumn

    public final TreeTableColumn<S,T> getTableColumn()
    Gets the value of the `tableColumn` property.
    Property description:
      The `TreeTableColumn` instance that backs this `TreeTableCell`.
    Returns:
      the value of the `tableColumn` property
    See Also:
      - `tableColumnProperty()`

  - ### getTreeTableView

    public final TreeTableView<S> getTreeTableView()
    Gets the value of the `treeTableView` property.
    Property description:
      The `TreeTableView` associated with this `TreeTableCell`.
    Returns:
      the value of the `treeTableView` property
    See Also:
      - `treeTableViewProperty()`

  - ### treeTableViewProperty

    public final ReadOnlyObjectProperty<TreeTableView<S>> treeTableViewProperty()
    The `TreeTableView` associated with this `TreeTableCell`.
    Returns:
      the `treeTableView` property
    See Also:
      - `getTreeTableView()`

  - ### getTableRow

    public final TreeTableRow<S> getTableRow()
    Gets the value of the property `tableRow`.
    Returns:
      the value of the property `tableRow`
    Since:
      17

  - ### tableRowProperty

    public final ReadOnlyObjectProperty<TreeTableRow<S>> tableRowProperty()
    The `TreeTableRow` that this `TreeTableCell` currently finds itself placed within.
    Returns:
      the `tableRow` property
    See Also:
      - `getTableRow()`

  - ### getTreeTableRow

    @Deprecated(since="17") public final TreeTableRow<S> getTreeTableRow()
    Deprecated.
    Use `getTableRow()` instead.
    Returns:
      the `TreeTableRow`

  - ### updateTreeTableView

    public final void updateTreeTableView(TreeTableView<S> tv)
    Updates the `TreeTableView` associated with this `TreeTableCell`. This is typically only done once when the `TreeTableCell` is first added to the `TreeTableView`.

    Note: This function is intended to be used by experts, primarily by those implementing new Skins. It is not common for developers or designers to access this function directly.

    Parameters:
      `tv` - the `TreeTableView` associated with this `TreeTableCell`

  - ### updateTableRow

    public final void updateTableRow(TreeTableRow<S> row)
    Updates the `TreeTableRow` associated with this `TreeTableCell`.

    Note: This function is intended to be used by experts, primarily by those implementing new Skins. It is not common for developers or designers to access this function directly.

    Parameters:
      `row` - the `TreeTableRow` associated with this `TreeTableCell`
    Since:
      17

  - ### updateTableColumn

    public final void updateTableColumn(TreeTableColumn<S,T> column)
    Updates the `TreeTableColumn` associated with this `TreeTableCell`.

    Note: This function is intended to be used by experts, primarily by those implementing new Skins. It is not common for developers or designers to access this function directly.

    Parameters:
      `column` - the `TreeTableColumn` associated with this `TreeTableCell`
    Since:
      17

  - ### updateTreeTableRow

    @Deprecated(since="17") public final void updateTreeTableRow(TreeTableRow<S> row)
    Deprecated.
    Use `updateTableRow(javafx.scene.control.TreeTableRow<S>)` instead.
    Parameters:
      `row` - the `TreeTableRow`

  - ### updateTreeTableColumn

    @Deprecated(since="17") public final void updateTreeTableColumn(TreeTableColumn<S,T> column)
    Deprecated.
    Use `updateTableColumn(javafx.scene.control.TreeTableColumn<S,T>)` instead.
    Parameters:
      `column` - the `TreeTableColumn`